#include "ki/rc.h"
#include "ki/memory.h"
#include "ki/sys.h"

RC* RCNew(void *ptr) {
  RC *rc = ki_malloc(sizeof(RC));

  RCInit(rc, ptr);

  return rc;
}

void RCInit(RC *rc, void *ptr) {
  rc->ptr = ptr;
  rc->refcount = 1;
}

void RCIncrement(RC *rc) {
  if (!rc->refcount) {
    fatal_error("RC refcount is 0");
  }

  rc->refcount++;
}

void RCDecrement(RC *rc) {
  if (!rc->refcount) {
    fatal_error("RC refcount is 0");
  }

  rc->refcount--;

  if (!rc->refcount) {
    free(rc->ptr);
    rc->ptr = NULL;
  }
}

/* vi: set et ts=2 sw=2: */

